
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity test_sequence is
Port ( 
  clk : in  STD_LOGIC;
  clr : in  STD_LOGIC;
  cmd : out  STD_LOGIC_VECTOR (2 downto 0);
  spd : out  STD_LOGIC_VECTOR (1 downto 0);
  pwm : in  STD_LOGIC);
end test_sequence;

architecture test_sequence_arch of test_sequence is

  type state_type is (S0, S1, S2, S3, S4, S5, S6, S7);
  signal next_state, present_state : state_type;
  
begin

  sync : process( clk, clr )
  begin
    if clr = '1'
	 then 
	   present_state <= S0;
	 elsif clk='1' and clk'event
	 then
	   present_state <= next_state;
    end if;
  end process;
  
  comb : process( present_state )
  begin
    case present_state is
	   when S0 =>
		  cmd <= "000";
		  spd <= pwm & pwm;
		  next_state <= S1;
	   when S1 =>
		  cmd <= "001";
		  spd <= pwm & pwm;  
		  next_state <= S2;
	   when S2 =>
		  cmd <= "001";
		  spd <= pwm & pwm;
		  next_state <= S3;
	   when S3 =>
		  cmd <= "100";
		  spd <= pwm & pwm;
		  next_state <= S0;
		when OTHERS =>  
		  cmd <= "000";
		  spd <= pwm & pwm;
		  next_state <= S0;
    end case;
  end process;

end test_sequence_arch;

